import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
//
import * as wijmo from '@mescius/wijmo';
import * as input from '@mescius/wijmo.input';
import { getData } from './data';
import { TableView } from './table-view';
import { ItemEditor } from './item-editor';
//
document.readyState === 'complete' ? init() : window.onload = init;
//
function init() {
//
// create a CollectionView
let view = new wijmo.CollectionView(getData(500), {
pageSize: 10,
newItemCreator: () => {
let newItem = getData(1)[0];
newItem.id = -1;
return newItem;
}
});
//
new TableView('#tableView', view, { amount: 'n2' });
new input.CollectionViewNavigator("#navigator", { cv: view });
new input.CollectionViewNavigator("#pager", { cv: view, byPage: true });
new ItemEditor('#editor', view);
//
let menu = new input.Menu("#pageSizeMenu", {
itemsSource: [
{ value: 0, text: 'No Paging' },
{ value: 10, text: '10' },
{ value: 15, text: '15' },
{ value: 30, text: '30' },
{ value: 50, text: '50' }
],
displayMemberPath: 'text',
selectedValuePath: 'value',
selectedValue: view.pageSize,
selectedIndexChanged: (sender) => {
if (sender.selectedIndex >= 0) {
updateMenuHeader(sender);
view.pageSize = sender.selectedValue;
}
}
});
updateMenuHeader(menu);
//
function updateMenuHeader(menu) {
if (menu.selectedIndex >= 0) {
menu.header = `Page Size: <b>${menu.selectedItem.text}</b>`;
}
}
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo CollectionView Overview</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.5/dist/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div class="container-fluid">
<div id="menu"></div>
<div class="row">
<div class="col-md-6">
<h4>Current Item</h4>
<div id="editor"></div>
</div>
<div class="col-md-6">
<h4>Navigation</h4>
<dl>
<dt>items</dt>
<dd>
<div id="navigator"></div>
</dd>
<dt>pages</dt>
<dd>
<div id="pager"></div>
</dd>
</dl>
<div id="pageSizeMenu"></div>
</div>
</div>
<div id="tableView"></div>
</div>
</body>
</html>
//
export function getData(count) {
let countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'], colors = ['Black', 'White', 'Red', 'Green', 'Blue'], data = [];
//
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let countryId = Math.floor(Math.random() * countries.length), colorId = Math.floor(Math.random() * colors.length);
//
// create the item
let item = {
id: i,
country: countries[countryId],
color: colors[colorId],
amount: Math.random() * 10000 - 5000
};
//
// add the item to the list
data.push(item);
}
//
return data;
}
.table {
margin-bottom: 0px !important;
}
import * as wijmo from '@mescius/wijmo';
//
export class ItemEditor extends wijmo.Control {
//
constructor(element, view) {
wijmo.assert(!!view, 'view must not be null.');
//
super(element);
//
this.applyTemplate('', this.getTemplate(), {
_tbId: 'id',
_tbCountry: 'country',
_tbColor: 'color',
_tbAmount: 'amount',
_btnEdit: 'edit',
_btnAdd: 'add',
_btnDelete: 'delete',
_btnCommit: 'commit',
_btnCancel: 'cancel'
});
//
this._btnEdit.addEventListener('click', () => this._edit());
this._btnAdd.addEventListener('click', () => this._add());
this._btnDelete.addEventListener('click', () => this._remove());
this._btnCommit.addEventListener('click', () => this._commit());
this._btnCancel.addEventListener('click', () => this._cancel());
//
this._view = view;
this._view.currentChanging.addHandler(() => {
if (this._view.isEditingItem) {
this._commit();
}
});
this._view.currentChanged.addHandler(() => this.invalidate());
//
this.invalidate();
}
refresh() {
super.refresh();
//
let cur = this._view.currentItem, edit = this._isEditing();
//
this._tbId.disabled = !edit;
this._tbCountry.disabled = !edit;
this._tbColor.disabled = !edit;
this._tbAmount.disabled = !edit;
//
this._tbId.value = cur ? cur.id.toString() : '';
this._tbCountry.value = cur ? cur.country.toString() : '';
this._tbColor.value = cur ? cur.color.toString() : '';
this._tbAmount.value = cur ? cur.amount.toString() : '';
//
let display = edit ? 'none' : '';
this._btnEdit.style.display = display;
this._btnAdd.style.display = display;
this._btnDelete.style.display = display;
//
display = edit ? '' : 'none';
this._btnCommit.style.display = display;
this._btnCancel.style.display = display;
}
//
_isEditing() {
return this._view.isEditingItem || this._view.isAddingNew;
}
//
_edit() {
this._view.editItem(this._view.currentItem);
this.invalidate();
}
//
_add() {
this._view.addNew();
}
//
_remove() {
this._view.remove(this._view.currentItem);
}
//
_commit() {
let cur = this._view.currentItem;
//
cur.id = this._tbId.value;
cur.country = this._tbCountry.value;
cur.color = this._tbColor.value;
cur.amount = this._tbAmount.value;
//
this._view.commitEdit();
this._view.commitNew();
this.invalidate();
}
//
_cancel() {
this._view.cancelEdit();
this._view.cancelNew();
this.invalidate();
}
}
ItemEditor.controlTemplate = `<dl class="row g-2 align-items-center">
<dt class="col-md-3 mb-0">ID</dt>
<dd class="col-md-9 mb-0">
<input type="text" class="form-control" wj-part="id" />
</dd>
<dt class="col-md-3 mb-0">Country</dt>
<dd class="col-md-9 mb-0">
<input type="text" class="form-control" wj-part="country" />
</dd>
<dt class="col-md-3 mb-0">Color</dt>
<dd class="col-md-9 mb-0">
<input type="text" class="form-control" wj-part="color" />
</dd>
<dt class="col-md-3 mb-0">Amount</dt>
<dd class="col-md-9 mb-0">
<input type="number" class="form-control" wj-part="amount" />
</dd>
<dt class="col-md-3 mb-0"></dt>
<dd class="col-md-9 mb-0">
<div class="btn-group data-btn-group">
<button class="btn btn-outline-secondary btn-sm" wj-part="edit">Edit</button>
<button class="btn btn-outline-secondary btn-sm" wj-part="add">Add</button>
<button class="btn btn-outline-secondary btn-sm" wj-part="delete">Delete</button>
<button class="btn btn-outline-secondary btn-sm" wj-part="commit">Commit</button>
<button class="btn btn-outline-secondary btn-sm" wj-part="cancel">Cancel</button>
</div>
</dd>
</dl>`;
import * as wijmo from '@mescius/wijmo';
//
export class TableView extends wijmo.Control {
//
constructor(selector, view, format) {
super(selector);
//
this.applyTemplate('table-responsive', this.getTemplate(), {
_table: 'table'
});
this._format = format || {};
//
this._view = view;
this._view.collectionChanged.addHandler(() => this.invalidate());
this._view.currentChanged.addHandler(() => this.invalidate());
//
this.invalidate();
}
//
refresh() {
this._table.innerHTML = '';
//
// create header
if (this._view.itemCount > 0) {
let item = this._view.items[0], head = this._table.createTHead(), row = head.insertRow();
//
row.className = 'table-active';
Object.keys(item).forEach(key => {
let cell = document.createElement('th');
cell.className = 'text-center';
//
// header text
let txt = document.createTextNode(wijmo.toHeaderCase(key) + '\u00A0'); // +
cell.appendChild(txt);
//
// sort button
let btn = document.createElement('button');
btn.className = 'btn btn-outline-secondary';
btn.textContent = this._getSort(key);
btn.addEventListener('click', () => this._toggleSort(key));
cell.appendChild(btn);
//
row.appendChild(cell);
});
}
//
// create body
let body = this._table.createTBody();
this._view.items.forEach(item => {
let row = body.insertRow();
//
if (item == this._view.currentItem) {
row.className = 'table-success';
}
//
row.addEventListener('click', () => this._moveCurrentTo(row, item));
//
Object.keys(item).forEach(key => {
let cell = row.insertCell(), fmt = this._format[key], val = item[key];
//
cell.textContent = fmt ? wijmo.format(`{val:${fmt}}`, { val: val }) : val;
cell.className = 'text-center';
});
});
}
//
_moveCurrentTo(row, item) {
if (!this._isEditingView && !this._isGroupRow(item)) {
this._view.moveCurrentTo(item);
}
}
//
get _isEditingView() {
return this._view.isEditingItem || this._view.isAddingNew;
}
//
_isGroupRow(item) {
return item instanceof wijmo.CollectionViewGroup;
}
//
_getSort(field) {
let sd = this._view.sortDescriptions;
//
if (sd.length > 0 && sd[0].property === field) {
return sd[0].ascending ? '▲' : '▼';
}
//
return '◇';
}
//
_toggleSort(field) {
let sd = this._view.sortDescriptions, ascending = true;
//
if (sd.length > 0 && sd[0].property === field) {
ascending = !sd[0].ascending;
}
//
// remove any old sort descriptors and add the new one
sd.splice(0, sd.length, new wijmo.SortDescription(field, ascending));
}
}
TableView.controlTemplate = '<table class="table table-sm table-bordered" wj-part="table"></table>';
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
},
meta: {
'*.css': { loader: 'css' },
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/wijmojs/5.20261.52-rc/',
'pcdn:': 'https://cdn.jsdelivr.net/npm/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'cdn:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'cdn:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'cdn:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'cdn:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'cdn:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'cdn:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'cdn:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'cdn:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'cdn:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'cdn:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'cdn:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'cdn:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'cdn:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'cdn:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'cdn:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'cdn:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'cdn:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'cdn:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'cdn:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'cdn:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'cdn:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'cdn:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'cdn:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'cdn:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'cdn:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'cdn:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'cdn:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'cdn:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'cdn:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'cdn:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'cdn:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'cdn:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'cdn:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'cdn:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'cdn:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'cdn:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'cdn:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'cdn:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'cdn:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'cdn:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'cdn:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'cdn:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'cdn:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'cdn:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'cdn:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'cdn:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'cdn:@mescius/wijmo.barcode.specialized/index.js',
jszip: 'pcdn:jszip@3.8.0/dist/jszip.js',
'bootstrap.css': 'pcdn:bootstrap@5.3.8/dist/css/bootstrap.min.css',
css: 'pcdn:systemjs-plugin-css@0.1.37/css.js',
'plugin-babel': 'pcdn:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'pcdn:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js',
},
node_modules: {
defaultExtension: 'js',
},
},
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import './styles.css';
import * as wijmo from '@mescius/wijmo';
import '@angular/compiler';
import { Component, Inject, enableProdMode, ɵresolveComponentResources } from '@angular/core';
import { BrowserModule, bootstrapApplication } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { WjInputModule } from '@mescius/wijmo.angular2.input';
import { DataService, TDataItem } from './app.data';
@Component({
standalone: true,
providers: [DataService],
imports: [WjInputModule, FormsModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html',
})
export class AppComponent {
private _timeOut: any;
cv: wijmo.CollectionView;
groupedList: any[];
filter: { id?: string; country?: string; color?: string; minAmount?: number | string };
constructor(@Inject(DataService) private dataService: DataService) {
this.cv = new wijmo.CollectionView(dataService.getData(500), {
pageSize: 10,
filter: this._filterFun.bind(this),
newItemCreator: () => {
var newItem = dataService.getData(1)[0];
newItem.id = -1;
return newItem;
},
});
this.groupedList = this.cv.items;
this.cv.collectionChanged.addHandler(() => {
this.groupedList = this.cv.items;
if (this.cv.groups && this.cv.groups.length > 0) {
this.groupedList = [];
this.cv.groups.forEach((group) => this._addGroup(group));
}
});
this.filter = { id: '', country: '', color: '', minAmount: '' };
}
doFilter() {
if (this._timeOut) {
clearTimeout(this._timeOut);
}
//
this._timeOut = setTimeout(() => {
this._timeOut = null;
this.cv.refresh();
}, 250);
}
// IEditableCollectionView commands
isEditing() {
return this.cv.isEditingItem || this.cv.isAddingNew;
}
edit() {
this.cv.editItem(this.cv.currentItem);
}
add() {
this.cv.addNew();
}
delete() {
this.cv.remove(this.cv.currentItem);
}
commit() {
this.cv.commitEdit();
this.cv.commitNew();
}
cancel() {
this.cv.cancelEdit();
this.cv.cancelNew();
}
moveCurrentTo(item: any) {
if (!this.isEditing() && !this.isGroup(item)) {
this.cv.moveCurrentTo(item);
}
}
// sorting
getSort(propName: string) {
let sd = this.cv.sortDescriptions;
if (sd.length > 0 && sd[0].property == propName) {
return sd[0].ascending ? '▲' : '▼';
}
return '◇';
}
toggleSort(propName: string) {
let sd = this.cv.sortDescriptions,
ascending = true;
if (sd.length > 0 && sd[0].property == propName) {
ascending = !sd[0].ascending;
}
// remove any old sort descriptors and add the new one
sd.splice(0, sd.length, new wijmo.SortDescription(propName, ascending));
}
// grouping
getGroup(propName: string) {
let index = this._findGroup(propName);
return index < 0
? /*'▯' +*/ Array(this.cv.groupDescriptions.length + 2).join('▷')
: /*'▮' +*/ Array(index + 2).join('▶');
}
toggleGroup(propName: string) {
let gd = this.cv.groupDescriptions,
index = this._findGroup(propName);
if (index >= 0) {
gd.removeAt(index);
} else {
if (propName == 'amount') {
// when grouping by amount, use ranges instead of specific values
gd.push(
new wijmo.PropertyGroupDescription(propName, (item: TDataItem) => {
if (item.amount > 1000) return 'Large Amounts';
if (item.amount > 100) return 'Medium Amounts';
if (item.amount > 0) return 'Small Amounts';
return 'Negative Amounts';
}),
);
} else {
// group by specific property values
gd.push(new wijmo.PropertyGroupDescription(propName));
}
}
}
isGroup(item: any) {
return item instanceof wijmo.CollectionViewGroup;
}
private _addGroup(g: wijmo.CollectionViewGroup) {
this.groupedList.push(g);
if (g.isBottomLevel) {
g.items.forEach((item) => this.groupedList.push(item));
} else {
g.groups.forEach((group) => this._addGroup(group));
}
}
private _findGroup(propName: string) {
let gd = this.cv.groupDescriptions;
for (let i = 0; i < gd.length; i++) {
let pgd = gd[i] as wijmo.PropertyGroupDescription;
if (pgd.propertyName == propName) {
return i;
}
}
return -1;
}
// filtering
private _filterFun(item: TDataItem) {
// check each filter parameter
let f = this.filter;
if (f) {
if ((f.id == 'odd' && item.id % 2 == 0) || (f.id == 'even' && item.id % 2 != 0)) {
return false;
}
if (f.country && item.country.indexOf(f.country) < 0) {
return false;
}
if (f.color && item.color.indexOf(f.color) < 0) {
return false;
}
if ((f.minAmount || f.minAmount === 0) && item.amount < Number(f.minAmount)) {
return false;
}
}
// all passed, return true to include the item
return true;
}
}
enableProdMode();
// Resolve resources (templateUrl, styleUrls etc), After resolution all URLs have been converted into `template` strings.
ɵresolveComponentResources(fetch).then(() => {
// Bootstrap application
bootstrapApplication(AppComponent).catch((err) => console.error(err));
});
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo CollectionView Overview</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- Polyfills -->
<script src="node_modules/core-js/client/shim.min.js"></script>
<script src="node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="container-fluid">
<div class="row">
<div class="col-md-6">
<h4>Current Item</h4>
<dl class="dl-horizontal">
<dt>ID</dt>
<dd>
<input type="text" class="form-control" [ngModel]="cv.currentItem?.id"
(ngModelChange)="cv.currentItem.id=$event" [disabled]="!isEditing()" />
</dd>
<dt>Country</dt>
<dd>
<input type="text" class="form-control" [ngModel]="cv.currentItem?.country"
(ngModelChange)="cv.currentItem.country=$event" [disabled]="!isEditing()" />
</dd>
<dt>Color</dt>
<dd>
<input type="text" class="form-control" [ngModel]="cv.currentItem?.color"
(ngModelChange)="cv.currentItem.color=$event" [disabled]="!isEditing()" />
</dd>
<dt>Amount</dt>
<dd>
<input type="number" class="form-control" [ngModel]="cv.currentItem?.amount"
(ngModelChange)="cv.currentItem.amount=$event" [disabled]="!isEditing()" />
</dd>
<dt></dt>
<dd>
<div class="btn-group data-btn-group">
<button (click)="edit()" [style.display]="!isEditing() ? '' : 'none'"
class="btn btn-default btn-sm">Edit</button>
<button (click)="add()" [style.display]="!isEditing() ? '' : 'none'"
class="btn btn-default btn-sm">Add</button>
<button (click)="delete()" [style.display]="!isEditing() ? '' : 'none'"
class="btn btn-default btn-sm">Delete</button>
<button (click)="commit()" [style.display]="isEditing() ? '' : 'none'"
class="btn btn-default btn-sm">Commit</button>
<button (click)="cancel()" [style.display]="isEditing() ? '' : 'none'"
class="btn btn-default btn-sm">Cancel</button>
</div>
</dd>
</dl>
</div>
<div class="col-md-6">
<h4>Navigation</h4>
<dl>
<dt>items</dt>
<dd>
<wj-collection-view-navigator [cv]="cv"></wj-collection-view-navigator>
</dd>
<dt>pages</dt>
<dd>
<wj-collection-view-pager [cv]="cv"></wj-collection-view-pager>
</dd>
</dl>
<wj-menu [(value)]="cv.pageSize" [header]="'Page Size'">
<wj-menu-item [value]="0">No Paging</wj-menu-item>
<wj-menu-item [value]="10">10</wj-menu-item>
<wj-menu-item [value]="15">15</wj-menu-item>
<wj-menu-item [value]="30">30</wj-menu-item>
<wj-menu-item [value]="50">50</wj-menu-item>
</wj-menu>
</div>
</div>
<table class="table table-condensed table-bordered">
<thead>
<tr class="active">
<th class="text-center">
<div class="btn-group">
<wj-menu [(value)]="filter.id" [header]="'ID'" (itemClicked)="doFilter()" style="display:block">
<wj-menu-item [value]="''">(All)</wj-menu-item>
<wj-menu-item [value]="'odd'">Odd</wj-menu-item>
<wj-menu-item [value]="'even'">Even</wj-menu-item>
</wj-menu>
<button class="btn btn-default" (click)="toggleSort('id')">{{getSort('id')}}</button>
</div>
</th>
<th class="text-center">
<div class="btn-group">
<wj-menu [(value)]="filter.country" [header]="'Country'" (itemClicked)="doFilter()"
style="display:block">
<wj-menu-item [value]="''">(All)</wj-menu-item>
<wj-menu-item [value]="'US'">US</wj-menu-item>
<wj-menu-item [value]="'Germany'">Germany</wj-menu-item>
<wj-menu-item [value]="'UK'">UK</wj-menu-item>
<wj-menu-item [value]="'Japan'">Japan</wj-menu-item>
<wj-menu-item [value]="'Italy'">Italy</wj-menu-item>
<wj-menu-item [value]="'Greece'">Greece</wj-menu-item>
<wj-menu-item [value]="'France'">France</wj-menu-item>
</wj-menu>
<button class="btn btn-default" (click)="toggleSort('country')">{{getSort('country')}}</button>
<button class="btn btn-default"
(click)="toggleGroup('country')">{{getGroup('country')}}</button>
</div>
</th>
<th class="text-center">
<div class="btn-group">
<wj-menu [(value)]="filter.color" [header]="'Color'" (itemClicked)="doFilter()"
style="display:block">
<wj-menu-item [value]="''">(All)</wj-menu-item>
<wj-menu-item [value]="'Black'">Black</wj-menu-item>
<wj-menu-item [value]="'White'">White</wj-menu-item>
<wj-menu-item [value]="'Red'">Red</wj-menu-item>
<wj-menu-item [value]="'Green'">Green</wj-menu-item>
<wj-menu-item [value]="'Blue'">Blue</wj-menu-item>
<wj-menu-item [value]="'Yellow'">Yellow</wj-menu-item>
<wj-menu-item [value]="'Brown'">Brown</wj-menu-item>
<wj-menu-item [value]="'Orange'">Orange</wj-menu-item>
</wj-menu>
<button class="btn btn-default" (click)="toggleSort('color')">{{getSort('color')}}</button>
<button class="btn btn-default" (click)="toggleGroup('color')">{{getGroup('color')}}</button>
</div>
</th>
<th class="text-center">
<div class="btn-group">
<wj-menu [(value)]="filter.minAmount" [header]="'Amount'" (itemClicked)="doFilter()"
style="display:block">
<wj-menu-item [value]="''">(All)</wj-menu-item>
<wj-menu-item [value]="0">> 0</wj-menu-item>
<wj-menu-item [value]="500">> 500</wj-menu-item>
<wj-menu-item [value]="1000">> 1,000</wj-menu-item>
</wj-menu>
<button class="btn btn-default" (click)="toggleSort('amount')">{{getSort('amount')}}</button>
<button class="btn btn-default" (click)="toggleGroup('amount')">{{getGroup('amount')}}</button>
</div>
</th>
</tr>
</thead>
<tbody>
@for (item of groupedList; track item;) {
<tr [class.success]="item === cv.currentItem" (click)="moveCurrentTo(item)">
<!-- group row -->
<td [style.display]="isGroup(item) ? '' : 'none'" colspan="4" class="active">
<span [style.display]="'inline-block'" [style.width.px]="item?.level * 25"></span>
<b>{{item.name}}</b> ({{item.items?.length}} items)
</td>
<!-- data row -->
<td [style.display]="isGroup(item) ? 'none' : ''" class="text-center">{{item.id}}</td>
<td [style.display]="isGroup(item) ? 'none' : ''" class="text-center">{{item.country}}</td>
<td [style.display]="isGroup(item) ? 'none' : ''" class="text-center">{{item.color}}</td>
<td [style.display]="isGroup(item) ? 'none' : ''" class="text-center">{{item.amount | number:'1.2-2'}}
</td>
</tr>
}
</tbody>
</table>
</div>
import { Injectable } from '@angular/core';
//
export type TDataItem = {
id: number;
country: string;
color: string;
amount: number;
}
//
@Injectable()
export class DataService {
// data used to generate random items
private _colors = ['Black', 'White', 'Red', 'Green', 'Blue'];
private _countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
//
getData(count: number) {
let data: TDataItem[] = [];
//
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let countryId = Math.floor(Math.random() * this._countries.length),
colorId = Math.floor(Math.random() * this._colors.length);
//
// add the item to the list
data.push({
id: i,
country: this._countries[countryId],
color: this._colors[colorId],
amount: Math.random() * 10000 - 5000
});
}
//
return data;
}
}
.table {
margin-bottom: 0px !important;
}
(function (global) {
SystemJS.config({
transpiler: './plugin-typescript.js',
typescriptOptions: {
"target": "ES2022",
"module": "system",
"emitDecoratorMetadata": true,
"experimentalDecorators": true,
},
baseURL: 'node_modules/',
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'systemjs-plugin-css' },
'*.mjs': {
format: 'esm'
},
},
paths: {
// paths serve as alias
'npm:': ''
},
packageConfigPaths: [
'/node_modules/*/package.json',
"/node_modules/@angular/*/package.json",
"/node_modules/@mescius/*/package.json"
],
map: {
'core-js': 'https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js',
'typescript': 'https://cdnjs.cloudflare.com/ajax/libs/typescript/5.2.2/typescript.min.js',
"rxjs": "https://cdnjs.cloudflare.com/ajax/libs/rxjs/7.8.1/rxjs.umd.min.js",
'systemjs-plugin-css': 'https://cdn.jsdelivr.net/npm/systemjs-plugin-css@0.1.37/css.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.angular2.chart.analytics": "npm:@mescius/wijmo.angular2.chart.analytics/index.js",
"@mescius/wijmo.angular2.chart.animation": "npm:@mescius/wijmo.angular2.chart.animation/index.js",
"@mescius/wijmo.angular2.chart.annotation": "npm:@mescius/wijmo.angular2.chart.annotation/index.js",
"@mescius/wijmo.angular2.chart.finance.analytics": "npm:@mescius/wijmo.angular2.chart.finance.analytics/index.js",
"@mescius/wijmo.angular2.chart.finance": "npm:@mescius/wijmo.angular2.chart.finance/index.js",
"@mescius/wijmo.angular2.chart.hierarchical": "npm:@mescius/wijmo.angular2.chart.hierarchical/index.js",
"@mescius/wijmo.angular2.chart.interaction": "npm:@mescius/wijmo.angular2.chart.interaction/index.js",
"@mescius/wijmo.angular2.chart.radar": "npm:@mescius/wijmo.angular2.chart.radar/index.js",
'@mescius/wijmo.angular2.chart.map': 'npm:@mescius/wijmo.angular2.chart.map/index.js',
"@mescius/wijmo.angular2.chart": "npm:@mescius/wijmo.angular2.chart/index.js",
"@mescius/wijmo.angular2.core": "npm:@mescius/wijmo.angular2.core/index.js",
"@mescius/wijmo.angular2.gauge": "npm:@mescius/wijmo.angular2.gauge/index.js",
"@mescius/wijmo.angular2.grid.detail": "npm:@mescius/wijmo.angular2.grid.detail/index.js",
"@mescius/wijmo.angular2.grid.filter": "npm:@mescius/wijmo.angular2.grid.filter/index.js",
"@mescius/wijmo.angular2.grid.grouppanel": "npm:@mescius/wijmo.angular2.grid.grouppanel/index.js",
"@mescius/wijmo.angular2.grid.search": "npm:@mescius/wijmo.angular2.grid.search/index.js",
"@mescius/wijmo.angular2.grid.multirow": "npm:@mescius/wijmo.angular2.grid.multirow/index.js",
"@mescius/wijmo.angular2.grid.sheet": "npm:@mescius/wijmo.angular2.grid.sheet/index.js",
'@mescius/wijmo.angular2.grid.transposed': 'npm:@mescius/wijmo.angular2.grid.transposed/index.js',
'@mescius/wijmo.angular2.grid.transposedmultirow': 'npm:@mescius/wijmo.angular2.grid.transposedmultirow/index.js',
"@mescius/wijmo.angular2.grid": "npm:@mescius/wijmo.angular2.grid/index.js",
"@mescius/wijmo.angular2.input": "npm:@mescius/wijmo.angular2.input/index.js",
"@mescius/wijmo.angular2.olap": "npm:@mescius/wijmo.angular2.olap/index.js",
"@mescius/wijmo.angular2.viewer": "npm:@mescius/wijmo.angular2.viewer/index.js",
"@mescius/wijmo.angular2.nav": "npm:@mescius/wijmo.angular2.nav/index.js",
"@mescius/wijmo.angular2.directivebase": "npm:@mescius/wijmo.angular2.directivebase/index.js",
'@mescius/wijmo.angular2.barcode.common': 'npm:@mescius/wijmo.angular2.barcode.common/index.js',
'@mescius/wijmo.angular2.barcode.composite': 'npm:@mescius/wijmo.angular2.barcode.composite/index.js',
'@mescius/wijmo.angular2.barcode.specialized': 'npm:@mescius/wijmo.angular2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'https://cdnjs.cloudflare.com/ajax/libs/jszip/3.10.1/jszip.min.js',
'@angular/core': 'npm:@angular/core/fesm2022/core.mjs',
'@angular/core/primitives/di': 'npm:@angular/core/fesm2022/primitives/di.mjs',
'@angular/core/primitives/signals': 'npm:@angular/core/fesm2022/primitives/signals.mjs',
'@angular/core/primitives/event-dispatch': 'npm:@angular/core/fesm2022/primitives/event-dispatch.mjs',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/http': 'npm:@angular/http/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
"./src": {
defaultExtension: 'ts'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);

import 'bootstrap.css';
import '@mescius/wijmo.styles/wijmo.css';
import ReactDOM from 'react-dom/client';
import React, { useEffect, useRef, useState } from 'react';
import useEvent from 'react-use-event-hook';
import * as wijmo from '@mescius/wijmo';
import * as wjInput from '@mescius/wijmo.react.input';
import './app.css';
import { getData } from './data';
const filter = { id: '', country: '', color: '', minAmount: '' };
function App() {
const [count, setCount] = useState(0);
const [cv] = useState(new wijmo.CollectionView(getData(500), {
pageSize: 10,
newItemCreator: () => {
var newItem = getData(1)[0];
newItem.id = -1;
return newItem;
}
}));
const [isEditing, setIsEditing] = useState(false);
const [groupedList, setGroupedList] = useState(cv.items);
const timeOut = useRef(null);
useEffect(() => {
cv.filter = filterFn;
cv.collectionChanged.addHandler(() => {
let gl = cv.items;
if (cv.groups && cv.groups.length > 0) {
gl = [];
cv.groups.forEach(group => addGroup(gl, group));
}
setGroupedList(gl);
});
cv.currentChanged.addHandler(() => {
isEditingFn();
forceUpdate();
});
}, []);
const forceUpdate = () => {
setCount((prevCount) => prevCount + 1);
};
const doFilter = () => {
if (timeOut.current) {
clearTimeout(timeOut.current);
}
//
timeOut.current = setTimeout(() => {
timeOut.current = null;
cv.refresh();
}, 250);
};
const pageSizeChanged = useEvent((sender) => {
if (sender.selectedItem) {
cv.pageSize = sender.selectedValue;
}
});
const idChanged = useEvent((sender) => {
if (sender.selectedItem) {
filter.id = sender.selectedValue;
doFilter();
}
});
const countryChanged = useEvent((sender) => {
if (sender.selectedItem) {
filter.country = sender.selectedValue;
doFilter();
}
});
const colorChanged = useEvent((sender) => {
if (sender.selectedItem) {
filter.color = sender.selectedValue;
doFilter();
}
});
const amountChanged = useEvent((sender) => {
if (sender.selectedItem) {
filter.minAmount = sender.selectedValue;
doFilter();
}
});
// IEditableCollectionView commands
const isEditingFn = () => {
setIsEditing(cv.isEditingItem || cv.isAddingNew);
};
const edit = () => {
cv.editItem(cv.currentItem);
isEditingFn();
};
const add = () => {
cv.addNew();
isEditingFn();
};
const deleteItem = () => {
cv.remove(cv.currentItem);
isEditingFn();
};
const commit = () => {
cv.commitEdit();
cv.commitNew();
isEditingFn();
};
const cancel = () => {
cv.cancelEdit();
cv.cancelNew();
isEditingFn();
};
const moveCurrentTo = (item) => {
if (!isEditing && !isGroup(item)) {
cv.moveCurrentTo(item);
forceUpdate();
}
};
// sorting
const getSort = (propName) => {
let sd = cv.sortDescriptions;
if (sd.length > 0 && sd[0].property == propName) {
return sd[0].ascending ? '▲' : '▼';
}
return '◇';
};
const toggleSort = (propName) => {
let sd = cv.sortDescriptions, ascending = true;
//
if (sd.length > 0 && sd[0].property == propName) {
ascending = !sd[0].ascending;
}
//
// remove any old sort descriptors and add the new one
sd.splice(0, sd.length, new wijmo.SortDescription(propName, ascending));
};
// grouping
const getGroup = (propName) => {
let index = findGroup(propName);
return index < 0
? /*'▯' +*/ Array(cv.groupDescriptions.length + 2).join('▷')
: /*'▮' +*/ Array(index + 2).join('▶');
};
const toggleGroup = (propName) => {
let gd = cv.groupDescriptions, index = findGroup(propName);
//
if (index >= 0) {
gd.removeAt(index);
}
else {
if (propName == 'amount') {
// when grouping by amount, use ranges instead of specific values
gd.push(new wijmo.PropertyGroupDescription(propName, (item) => {
if (item.amount > 1000)
return 'Large Amounts';
if (item.amount > 100)
return 'Medium Amounts';
if (item.amount > 0)
return 'Small Amounts';
//
return 'Negative Amounts';
}));
}
else {
// group by specific property values
gd.push(new wijmo.PropertyGroupDescription(propName));
}
}
};
const isGroup = (item) => {
return item instanceof wijmo.CollectionViewGroup;
};
const addGroup = (groupedList, g) => {
groupedList.push(g);
//
if (g.isBottomLevel) {
g.items.forEach((item) => groupedList.push(item));
}
else {
g.groups.forEach((group) => addGroup(groupedList, group));
}
};
const findGroup = (propName) => {
let gd = cv.groupDescriptions;
for (let i = 0; i < gd.length; i++) {
let pgd = gd[i];
if (pgd.propertyName == propName) {
return i;
}
}
return -1;
};
// filtering
const filterFn = (item) => {
// check each filter parameter
let f = filter;
//
if (f) {
if ((f.id == 'odd' && item.id % 2 == 0) || (f.id == 'even' && item.id % 2 != 0)) {
return false;
}
//
if (f.country && item.country.indexOf(f.country) < 0) {
return false;
}
//
if (f.color && item.color.indexOf(f.color) < 0) {
return false;
}
//
if ((f.minAmount || f.minAmount === 0) && item.amount < f.minAmount) {
return false;
}
}
//
// all passed, return true to include the item
return true;
};
const updateCurrentItem = (target, binding) => {
cv.currentItem[binding] = target.value;
forceUpdate();
};
return (<div className="container-fluid">
<div className="row">
<div className="col-md-6">
<h4>Current Item</h4>
<dl className="dl-horizontal">
<dt>ID</dt>
<dd>
<input type="text" className="form-control" value={cv.currentItem ? cv.currentItem.id : ''} onChange={e => updateCurrentItem(e.target, 'id')} disabled={!isEditing}/>
</dd>
<dt>Country</dt>
<dd>
<input type="text" className="form-control" value={cv.currentItem ? cv.currentItem.country : ''} onChange={e => updateCurrentItem(e.target, 'country')} disabled={!isEditing}/>
</dd>
<dt>Color</dt>
<dd>
<input type="text" className="form-control" value={cv.currentItem ? cv.currentItem.color : ''} onChange={e => updateCurrentItem(e.target, 'color')} disabled={!isEditing}/>
</dd>
<dt>Amount</dt>
<dd>
<input type="number" className="form-control" value={cv.currentItem ? cv.currentItem.amount : ''} onChange={e => updateCurrentItem(e.target, 'amount')} disabled={!isEditing}/>
</dd>
<dt></dt>
<dd>
<div className="btn-group data-btn-group">
<button onClick={edit} style={{ display: !isEditing ? '' : 'none' }} className="btn btn-default btn-sm">Edit</button>
<button onClick={add} style={{ display: !isEditing ? '' : 'none' }} className="btn btn-default btn-sm">Add</button>
<button onClick={deleteItem} style={{ display: !isEditing ? '' : 'none' }} className="btn btn-default btn-sm">Delete</button>
<button onClick={commit} style={{ display: isEditing ? '' : 'none' }} className="btn btn-default btn-sm">Commit</button>
<button onClick={cancel} style={{ display: isEditing ? '' : 'none' }} className="btn btn-default btn-sm">Cancel</button>
</div>
</dd>
</dl>
</div>
<div className="col-md-6">
<h4>Navigation</h4>
<dl>
<dt>items</dt>
<dd>
<wjInput.CollectionViewNavigator cv={cv}></wjInput.CollectionViewNavigator>
</dd>
<dt>pages</dt>
<dd>
<wjInput.CollectionViewNavigator cv={cv} byPage></wjInput.CollectionViewNavigator>
</dd>
</dl>
<wjInput.Menu header='Page Size' value={cv.pageSize} itemClicked={pageSizeChanged}>
<wjInput.MenuItem value={0}>No Paging</wjInput.MenuItem>
<wjInput.MenuItem value={10}>10</wjInput.MenuItem>
<wjInput.MenuItem value={15}>15</wjInput.MenuItem>
<wjInput.MenuItem value={30}>30</wjInput.MenuItem>
<wjInput.MenuItem value={50}>50</wjInput.MenuItem>
</wjInput.Menu>
</div>
</div>
<table className="table table-condensed table-bordered">
<thead>
<tr className="active">
<th className="text-center">
<div className="btn-group">
<wjInput.Menu header='ID' value={filter.id} itemClicked={idChanged} style={{ display: "block" }}>
<wjInput.MenuItem value=''>(All)</wjInput.MenuItem>
<wjInput.MenuItem value='odd'>Odd</wjInput.MenuItem>
<wjInput.MenuItem value='even'>Even</wjInput.MenuItem>
</wjInput.Menu>
<button className="btn btn-default" onClick={e => toggleSort('id')}>{getSort('id')}</button>
</div>
</th>
<th className="text-center">
<div className="btn-group">
<wjInput.Menu header='Country' value={filter.country} itemClicked={countryChanged} style={{ display: "block" }}>
<wjInput.MenuItem value="">(All)</wjInput.MenuItem>
<wjInput.MenuItem value="US">US</wjInput.MenuItem>
<wjInput.MenuItem value="Germany">Germany</wjInput.MenuItem>
<wjInput.MenuItem value="UK">UK</wjInput.MenuItem>
<wjInput.MenuItem value="Japan">Japan</wjInput.MenuItem>
<wjInput.MenuItem value="Italy">Italy</wjInput.MenuItem>
<wjInput.MenuItem value="Greece">Greece</wjInput.MenuItem>
<wjInput.MenuItem value="France">France</wjInput.MenuItem>
</wjInput.Menu>
<button className="btn btn-default" onClick={e => toggleSort('country')}>{getSort('country')}</button>
<button className="btn btn-default" onClick={e => toggleGroup('country')}>{getGroup('country')}</button>
</div>
</th>
<th className="text-center">
<div className="btn-group">
<wjInput.Menu header='Color' value={filter.color} itemClicked={colorChanged} style={{ display: "block" }}>
<wjInput.MenuItem value="">(All)</wjInput.MenuItem>
<wjInput.MenuItem value="Black">Black</wjInput.MenuItem>
<wjInput.MenuItem value="White">White</wjInput.MenuItem>
<wjInput.MenuItem value="Red">Red</wjInput.MenuItem>
<wjInput.MenuItem value="Green">Green</wjInput.MenuItem>
<wjInput.MenuItem value="Blue">Blue</wjInput.MenuItem>
<wjInput.MenuItem value="Yellow">Yellow</wjInput.MenuItem>
<wjInput.MenuItem value="Brown">Brown</wjInput.MenuItem>
<wjInput.MenuItem value="Orange">Orange</wjInput.MenuItem>
</wjInput.Menu>
<button className="btn btn-default" onClick={e => toggleSort('color')}>{getSort('color')}</button>
<button className="btn btn-default" onClick={e => toggleGroup('color')}>{getGroup('color')}</button>
</div>
</th>
<th className="text-center">
<div className="btn-group">
<wjInput.Menu header='Amount' value={filter.minAmount} itemClicked={amountChanged} style={{ display: "block" }}>
<wjInput.MenuItem value="">(All)</wjInput.MenuItem>
<wjInput.MenuItem value={0}>{'>'} 0</wjInput.MenuItem>
<wjInput.MenuItem value={500}>{'>'} 500</wjInput.MenuItem>
<wjInput.MenuItem value={1000}>{'>'} 1000</wjInput.MenuItem>
</wjInput.Menu>
<button className="btn btn-default" onClick={e => toggleSort('amount')}>{getSort('amount')}</button>
<button className="btn btn-default" onClick={e => toggleGroup('amount')}>{getGroup('amount')}</button>
</div>
</th>
</tr>
</thead>
<tbody>
{groupedList.map((item, index) => {
return <tr key={index} className={item == cv.currentItem ? 'success' : ''} onClick={e => moveCurrentTo(item)}>
<td style={{ display: isGroup(item) ? '' : 'none' }} colSpan={4} className="active">
<span style={{ display: 'inline-block', width: (item.level * 25) + 'px' }}></span>
<b>{item.name}</b> ( items)
</td>
<td style={{ display: isGroup(item) ? 'none' : '' }} className="text-center">{item.id}</td>
<td style={{ display: isGroup(item) ? 'none' : '' }} className="text-center">{item.country}</td>
<td style={{ display: isGroup(item) ? 'none' : '' }} className="text-center">{item.color}</td>
<td style={{ display: isGroup(item) ? 'none' : '' }} className="text-center">{item.amount}</td>
</tr>;
})}
</tbody>
</table>
</div>);
}
const container = document.getElementById('app');
if (container) {
const root = ReactDOM.createRoot(container);
root.render(<App />);
}
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo CollectionView Overview</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.19.40/system.src.js" integrity="sha512-G6mEj6h18+m3MvzdviSDfPle/TfH0//cXcB33AKlNR/Rha0yQsKefDZKRTkIZos97HEGq2JMV1RT5ybMoQ3WsQ==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.table {
margin-bottom: 0px !important;
}
const _colors = ['Black', 'White', 'Red', 'Green', 'Blue'];
const _countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
export function getData(count) {
let data = [];
//
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let countryId = Math.floor(Math.random() * _countries.length), colorId = Math.floor(Math.random() * _colors.length);
//
// add the item to the list
data.push({
id: i,
country: _countries[countryId],
color: _colors[colorId],
amount: Math.random() * 10000 - 5000
});
}
//
return data;
}
(function (global) {
window.process = {
env: {
NODE_ENV: "production"
}
}
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'jszip': 'npm:jszip/dist/jszip.js',
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.grid.immutable': 'npm:@mescius/wijmo.grid.immutable/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.react.chart.analytics": "npm:@mescius/wijmo.react.chart.analytics/index.js",
"@mescius/wijmo.react.chart.animation": "npm:@mescius/wijmo.react.chart.animation/index.js",
"@mescius/wijmo.react.chart.annotation": "npm:@mescius/wijmo.react.chart.annotation/index.js",
"@mescius/wijmo.react.chart.finance.analytics": "npm:@mescius/wijmo.react.chart.finance.analytics/index.js",
"@mescius/wijmo.react.chart.finance": "npm:@mescius/wijmo.react.chart.finance/index.js",
"@mescius/wijmo.react.chart.hierarchical": "npm:@mescius/wijmo.react.chart.hierarchical/index.js",
"@mescius/wijmo.react.chart.interaction": "npm:@mescius/wijmo.react.chart.interaction/index.js",
"@mescius/wijmo.react.chart.radar": "npm:@mescius/wijmo.react.chart.radar/index.js",
"@mescius/wijmo.react.chart": "npm:@mescius/wijmo.react.chart/index.js",
"@mescius/wijmo.react.core": "npm:@mescius/wijmo.react.core/index.js",
'@mescius/wijmo.react.chart.map': 'npm:@mescius/wijmo.react.chart.map/index.js',
"@mescius/wijmo.react.gauge": "npm:@mescius/wijmo.react.gauge/index.js",
"@mescius/wijmo.react.grid.detail": "npm:@mescius/wijmo.react.grid.detail/index.js",
"@mescius/wijmo.react.grid.filter": "npm:@mescius/wijmo.react.grid.filter/index.js",
"@mescius/wijmo.react.grid.grouppanel": "npm:@mescius/wijmo.react.grid.grouppanel/index.js",
'@mescius/wijmo.react.grid.search': 'npm:@mescius/wijmo.react.grid.search/index.js',
"@mescius/wijmo.react.grid.multirow": "npm:@mescius/wijmo.react.grid.multirow/index.js",
"@mescius/wijmo.react.grid.sheet": "npm:@mescius/wijmo.react.grid.sheet/index.js",
'@mescius/wijmo.react.grid.transposed': 'npm:@mescius/wijmo.react.grid.transposed/index.js',
'@mescius/wijmo.react.grid.transposedmultirow': 'npm:@mescius/wijmo.react.grid.transposedmultirow/index.js',
'@mescius/wijmo.react.grid.immutable': 'npm:@mescius/wijmo.react.grid.immutable/index.js',
"@mescius/wijmo.react.grid": "npm:@mescius/wijmo.react.grid/index.js",
"@mescius/wijmo.react.input": "npm:@mescius/wijmo.react.input/index.js",
"@mescius/wijmo.react.olap": "npm:@mescius/wijmo.react.olap/index.js",
"@mescius/wijmo.react.viewer": "npm:@mescius/wijmo.react.viewer/index.js",
"@mescius/wijmo.react.nav": "npm:@mescius/wijmo.react.nav/index.js",
"@mescius/wijmo.react.base": "npm:@mescius/wijmo.react.base/index.js",
'@mescius/wijmo.react.barcode.common': 'npm:@mescius/wijmo.react.barcode.common/index.js',
'@mescius/wijmo.react.barcode.composite': 'npm:@mescius/wijmo.react.barcode.composite/index.js',
'@mescius/wijmo.react.barcode.specialized': 'npm:@mescius/wijmo.react.barcode.specialized/index.js',
'jszip': 'npm:jszip/dist/jszip.js',
'react': 'npm:react/index.js',
'react-dom': 'npm:react-dom/index.js',
'react-dom/client': 'npm:react-dom/client.js',
"scheduler": "npm:scheduler/index.js",
'redux': 'npm:redux/dist/redux.min.js',
'react-redux': 'npm:react-redux/dist/react-redux.min.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
"react-use-event-hook": "npm:react-use-event-hook/dist/esm/useEvent.js",
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

<template>
<div class="container-fluid">
<div class="row">
<div class="col-md-6">
<h4>Current Item</h4>
<dl class="dl-horizontal">
<div v-if="cv.currentItem">
<dt>ID</dt>
<dd>
<input type="text" class="form-control" v-model="cv.currentItem.id"
:disabled="!isEditing()" />
</dd>
<dt>Country</dt>
<dd>
<input type="text" class="form-control" v-model="cv.currentItem.country"
:disabled="!isEditing()" />
</dd>
<dt>Color</dt>
<dd>
<input type="text" class="form-control" v-model="cv.currentItem.color"
:disabled="!isEditing()" />
</dd>
<dt>Amount</dt>
<dd>
<input type="number" class="form-control" v-model="cv.currentItem.amount"
:disabled="!isEditing()" />
</dd>
<dt></dt>
<dd>
<div class="btn-group data-btn-group">
<button @click="edit()" v-bind:style="{ display: !isEditing() ? '' : 'none' }"
class="btn btn-default btn-sm">Edit</button>
<button @click="add()" v-bind:style="{ display: !isEditing() ? '' : 'none' }"
class="btn btn-default btn-sm">Add</button>
<button @click="deleteItem()" v-bind:style="{ display: !isEditing() ? '' : 'none' }"
class="btn btn-default btn-sm">Delete</button>
<button @click="commit()" v-bind:style="{ display: isEditing() ? '' : 'none' }"
class="btn btn-default btn-sm">Commit</button>
<button @click="cancel()" v-bind:style="{ display: isEditing() ? '' : 'none' }"
class="btn btn-default btn-sm">Cancel</button>
</div>
</dd>
</div>
</dl>
</div>
<div class="col-md-6">
<h4>Navigation</h4>
<dl>
<dt>items</dt>
<dd>
<wj-collection-view-navigator :cv="cv"></wj-collection-view-navigator>
</dd>
<dt>pages</dt>
<dd>
<wj-collection-view-navigator :cv="cv" :byPage="true"></wj-collection-view-navigator>
</dd>
</dl>
<wj-menu :value="cv.pageSize" :header="'Page Size'" :itemClicked="selectionPageChanged">
<wj-menu-item :value="0">No Paging</wj-menu-item>
<wj-menu-item :value="10">10</wj-menu-item>
<wj-menu-item :value="15">15</wj-menu-item>
<wj-menu-item :value="30">30</wj-menu-item>
<wj-menu-item :value="50">50</wj-menu-item>
</wj-menu>
</div>
</div>
<table class="table table-condensed table-bordered">
<thead>
<tr class="active">
<th class="text-center">
<div class="btn-group">
<wj-menu :header="'ID'" :itemClicked="selectionIDChanged" :value="filter.id"
style="display:block">
<wj-menu-item :value="''">(All)</wj-menu-item>
<wj-menu-item :value="'odd'">Odd</wj-menu-item>
<wj-menu-item :value="'even'">Even</wj-menu-item>
</wj-menu>
<button class="btn btn-default" @click="toggleSort('id')">{{ getSort('id') }}</button>
</div>
</th>
<th class="text-center">
<div class="btn-group">
<wj-menu :header="'Country'" :itemClicked="selectionCountryChanged" :value="filter.country"
style="display:block">
<wj-menu-item :value="''">(All)</wj-menu-item>
<wj-menu-item :value="'US'">US</wj-menu-item>
<wj-menu-item :value="'Germany'">Germany</wj-menu-item>
<wj-menu-item :value="'UK'">UK</wj-menu-item>
<wj-menu-item :value="'Japan'">Japan</wj-menu-item>
<wj-menu-item :value="'Italy'">Italy</wj-menu-item>
<wj-menu-item :value="'Greece'">Greece</wj-menu-item>
<wj-menu-item :value="'France'">France</wj-menu-item>
</wj-menu>
<button class="btn btn-default" @click="toggleSort('country')">{{
getSort('country') }}</button>
<button class="btn btn-default" @click="toggleGroup('country')">{{
getGroup('country') }}</button>
</div>
</th>
<th class="text-center">
<div class="btn-group">
<wj-menu :header="'Color'" :itemClicked="selectionColorChanged" :value="filter.color"
style="display:block">
<wj-menu-item :value="''">(All)</wj-menu-item>
<wj-menu-item :value="'Black'">Black</wj-menu-item>
<wj-menu-item :value="'White'">White</wj-menu-item>
<wj-menu-item :value="'Red'">Red</wj-menu-item>
<wj-menu-item :value="'Green'">Green</wj-menu-item>
<wj-menu-item :value="'Blue'">Blue</wj-menu-item>
<wj-menu-item :value="'Yellow'">Yellow</wj-menu-item>
<wj-menu-item :value="'Brown'">Brown</wj-menu-item>
<wj-menu-item :value="'Orange'">Orange</wj-menu-item>
</wj-menu>
<button class="btn btn-default" @click="toggleSort('color')">
{{ getSort('color') }}
</button>
<button class="btn btn-default" @click="toggleGroup('color')">
{{ getGroup('color') }}
</button>
</div>
</th>
<th class="text-center">
<div class="btn-group">
<wj-menu :header="'Amount'" :itemClicked="selectionAmountChanged" :value="filter.minAmount"
style="display:block">
<wj-menu-item :value="''">(All)</wj-menu-item>
<wj-menu-item :value="0">> 0</wj-menu-item>
<wj-menu-item :value="500">> 500</wj-menu-item>
<wj-menu-item :value="1000">> 1,000</wj-menu-item>
</wj-menu>
<button class="btn btn-default" @click="toggleSort('amount')">
{{ getSort('amount') }}
</button>
<button class="btn btn-default" @click="toggleGroup('amount')">
{{ getGroup('amount') }}
</button>
</div>
</th>
</tr>
</thead>
<tbody>
<tr v-for="item in groupedList" v-bind:key="item" v-bind:class="{ success: item == cv.currentItem }"
@click="moveCurrentTo(item)">
<!-- group row -->
<td v-bind:style="{ display: isGroup(item) ? '' : 'none' }" colspan="4" class="active">
<span v-bind:style="{ display: 'inline-block', width: (item.level * 25) + 'px' }"></span>
<b>{{ item.name }}</b> ({{ item.items && item.items.length }} items)
</td>
<!-- data row -->
<td v-bind:style="{ display: isGroup(item) ? 'none' : '' }" class="text-center">
{{ item.id }}
</td>
<td v-bind:style="{ display: isGroup(item) ? 'none' : '' }" class="text-center">
{{ item.country }}
</td>
<td v-bind:style="{ display: isGroup(item) ? 'none' : '' }" class="text-center">
{{ item.color }}
</td>
<td v-bind:style="{ display: isGroup(item) ? 'none' : '' }" class="text-center">
{{ formatNumber(item.amount, "n2") }}
</td>
</tr>
</tbody>
</table>
</div>
</template>
<script setup>
import { getData } from "./data";
import * as wijmo from "@mescius/wijmo";
import { ref, onMounted } from "vue";
const filter = ref({});
const groupedList = ref([]);
const testText = ref("");
const cv = ref(
new wijmo.CollectionView(getData(500), {
pageSize: 10,
filter: _filterFun.bind(this),
newItemCreator: () => {
var newItem = getData(1)[0];
newItem.id = -1;
return newItem;
},
}),
);
const _timeOut = ref(null);
onMounted(function () {
filter.value = { id: "", country: "", color: "", minAmount: "" };
window["cv"] = cv.value;
groupedList.value = cv.value.items;
//
cv.value.collectionChanged.addHandler(() => {
groupedList.value = cv.value.items;
if (cv.value.groups && cv.value.groups.length > 0) {
groupedList.value = [];
cv.value.groups.forEach((group) => _addGroup(group));
}
});
});
function doFilter() {
if (_timeOut.value) {
clearTimeout(_timeOut.value);
}
//
_timeOut.value = setTimeout(() => {
_timeOut.value = null;
cv.value.refresh();
}, 250);
}
function getFilteredItem(source, value) {
let item = source.filter((item) => {
return item.value == value;
})[0];
if (item !== undefined) {
return item.header;
}
}
function selectionPageChanged(menu) {
cv.value.pageSize = menu.selectedValue;
}
function selectionIDChanged(menu) {
filter.value.id = menu.selectedValue;
doFilter();
}
function selectionCountryChanged(menu) {
filter.value.country = menu.selectedValue;
doFilter();
}
function selectionColorChanged(menu) {
filter.value.color = menu.selectedValue;
doFilter();
}
function selectionAmountChanged(menu) {
filter.value.minAmount = menu.selectedValue;
doFilter();
}
//
// IEditableCollectionView commands
function isEditing() {
return cv.value.isEditingItem || cv.value.isAddingNew;
}
function edit() {
cv.value.editItem(cv.value.currentItem);
}
function add() {
cv.value.addNew();
}
function deleteItem() {
cv.value.remove(cv.value.currentItem);
}
function commit() {
cv.value.commitEdit();
cv.value.commitNew();
}
function cancel() {
cv.value.cancelEdit();
cv.value.cancelNew();
}
function moveCurrentTo(item) {
if (!isEditing() && !isGroup(item)) {
cv.value.moveCurrentTo(item);
}
}
//
// sorting
function getSort(propName) {
let sd = cv.value.sortDescriptions;
if (sd.length > 0 && sd[0].property == propName) {
return sd[0].ascending ? "▲" : "▼";
}
return "◇";
}
function toggleSort(propName) {
let sd = cv.value.sortDescriptions,
ascending = true;
//
if (sd.length > 0 && sd[0].property == propName) {
ascending = !sd[0].ascending;
}
//
// remove any old sort descriptors and add the new one
sd.splice(0, sd.length, new wijmo.SortDescription(propName, ascending));
}
//
// grouping
function getGroup(propName) {
let index = _findGroup(propName);
return index < 0 ? /*'▯' +*/ Array(cv.value.groupDescriptions.length + 2).join("▷") : /*'▮' +*/ Array(index + 2).join("▶");
}
function toggleGroup(propName) {
let gd = cv.value.groupDescriptions,
index = _findGroup(propName);
//
if (index >= 0) {
gd.removeAt(index);
} else {
if (propName == "amount") {
// when grouping by amount, use ranges instead of specific values
gd.push(
new wijmo.PropertyGroupDescription(propName, (item) => {
if (item.amount > 1000) return "Large Amounts";
if (item.amount > 100) return "Medium Amounts";
if (item.amount > 0) return "Small Amounts";
//
return "Negative Amounts";
}),
);
} else {
// group by specific property values
gd.push(new wijmo.PropertyGroupDescription(propName));
}
}
}
function isGroup(item) {
return item instanceof wijmo.CollectionViewGroup;
}
function _addGroup(g) {
groupedList.value.push(g);
//
if (g.isBottomLevel) {
g.items.forEach((item) => groupedList.value.push(item));
} else {
g.groups.forEach((group) => _addGroup(group));
}
}
function _findGroup(propName) {
let gd = cv.value.groupDescriptions;
//
for (let i = 0; i < gd.length; i++) {
if (gd[i].propertyName == propName) {
return i;
}
}
//
return -1;
}
// filtering
function _filterFun(item) {
// check each filter parameter
let f = filter.value;
//
if (f) {
if ((f.id == "odd" && item.id % 2 == 0) || (f.id == "even" && item.id % 2 != 0)) {
return false;
}
//
if (f.country && item.country.indexOf(f.country) < 0) {
return false;
}
//
if (f.color && item.color.indexOf(f.color) < 0) {
return false;
}
//
if ((f.minAmount || f.minAmount === 0) && item.amount < f.minAmount) {
return false;
}
}
//
// all passed, return true to include the item
return true;
}
function formatNumber(val, format) {
return val ? wijmo.Globalize.formatNumber(val, format) : "";
}
</script>
<style>
.table {
margin-bottom: 0px !important;
}
</style>
<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<title>MESCIUS Wijmo CollectionView Overview</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<!-- SystemJS -->
<script src="compiler.js" type="module"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/systemjs/0.21.5/system.src.js" integrity="sha512-skZbMyvYdNoZfLmiGn5ii6KmklM82rYX2uWctBhzaXPxJgiv4XBwJnFGr5k8s+6tE1pcR1nuTKghozJHyzMcoA==" crossorigin="anonymous"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('./src/app.js');
</script>
</head>
<body>
<div id="app">
</div>
</body>
</html>
export function getData(count) {
// data used to generate random items
let _colors = ['Black', 'White', 'Red', 'Green', 'Blue'];
let _countries = ['US', 'Germany', 'UK', 'Japan', 'Italy', 'Greece'];
let data = [];
//
// add count items
for (let i = 0; i < count; i++) {
// constants used to create data items
let countryId = Math.floor(Math.random() * _countries.length),
colorId = Math.floor(Math.random() * _colors.length);
//
// add the item to the list
data.push({
id: i,
country: _countries[countryId],
color: _colors[colorId],
amount: Math.random() * 10000 - 5000
});
}
return data;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
meta: {
'*.css': { loader: 'css' },
'*.vue': { loader: '../plugin-vue/index.js' }
//'*.vue': { loader: 'systemjs-plugin-vue' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/wijmo': 'npm:@mescius/wijmo/index.js',
'@mescius/wijmo.input': 'npm:@mescius/wijmo.input/index.js',
'@mescius/wijmo.styles': 'npm:@mescius/wijmo.styles',
'@mescius/wijmo.cultures': 'npm:@mescius/wijmo.cultures',
'@mescius/wijmo.chart': 'npm:@mescius/wijmo.chart/index.js',
'@mescius/wijmo.chart.analytics': 'npm:@mescius/wijmo.chart.analytics/index.js',
'@mescius/wijmo.chart.animation': 'npm:@mescius/wijmo.chart.animation/index.js',
'@mescius/wijmo.chart.annotation': 'npm:@mescius/wijmo.chart.annotation/index.js',
'@mescius/wijmo.chart.finance': 'npm:@mescius/wijmo.chart.finance/index.js',
'@mescius/wijmo.chart.finance.analytics': 'npm:@mescius/wijmo.chart.finance.analytics/index.js',
'@mescius/wijmo.chart.hierarchical': 'npm:@mescius/wijmo.chart.hierarchical/index.js',
'@mescius/wijmo.chart.interaction': 'npm:@mescius/wijmo.chart.interaction/index.js',
'@mescius/wijmo.chart.radar': 'npm:@mescius/wijmo.chart.radar/index.js',
'@mescius/wijmo.chart.render': 'npm:@mescius/wijmo.chart.render/index.js',
'@mescius/wijmo.chart.webgl': 'npm:@mescius/wijmo.chart.webgl/index.js',
'@mescius/wijmo.chart.map': 'npm:@mescius/wijmo.chart.map/index.js',
'@mescius/wijmo.gauge': 'npm:@mescius/wijmo.gauge/index.js',
'@mescius/wijmo.grid': 'npm:@mescius/wijmo.grid/index.js',
'@mescius/wijmo.grid.detail': 'npm:@mescius/wijmo.grid.detail/index.js',
'@mescius/wijmo.grid.filter': 'npm:@mescius/wijmo.grid.filter/index.js',
'@mescius/wijmo.grid.search': 'npm:@mescius/wijmo.grid.search/index.js',
'@mescius/wijmo.grid.style': 'npm:@mescius/wijmo.grid.style/index.js',
'@mescius/wijmo.grid.grouppanel': 'npm:@mescius/wijmo.grid.grouppanel/index.js',
'@mescius/wijmo.grid.multirow': 'npm:@mescius/wijmo.grid.multirow/index.js',
'@mescius/wijmo.grid.transposed': 'npm:@mescius/wijmo.grid.transposed/index.js',
'@mescius/wijmo.grid.transposedmultirow': 'npm:@mescius/wijmo.grid.transposedmultirow/index.js',
'@mescius/wijmo.grid.pdf': 'npm:@mescius/wijmo.grid.pdf/index.js',
'@mescius/wijmo.grid.sheet': 'npm:@mescius/wijmo.grid.sheet/index.js',
'@mescius/wijmo.grid.xlsx': 'npm:@mescius/wijmo.grid.xlsx/index.js',
'@mescius/wijmo.grid.selector': 'npm:@mescius/wijmo.grid.selector/index.js',
'@mescius/wijmo.grid.cellmaker': 'npm:@mescius/wijmo.grid.cellmaker/index.js',
'@mescius/wijmo.nav': 'npm:@mescius/wijmo.nav/index.js',
'@mescius/wijmo.odata': 'npm:@mescius/wijmo.odata/index.js',
'@mescius/wijmo.olap': 'npm:@mescius/wijmo.olap/index.js',
'@mescius/wijmo.rest': 'npm:@mescius/wijmo.rest/index.js',
'@mescius/wijmo.pdf': 'npm:@mescius/wijmo.pdf/index.js',
'@mescius/wijmo.pdf.security': 'npm:@mescius/wijmo.pdf.security/index.js',
'@mescius/wijmo.viewer': 'npm:@mescius/wijmo.viewer/index.js',
'@mescius/wijmo.xlsx': 'npm:@mescius/wijmo.xlsx/index.js',
'@mescius/wijmo.undo': 'npm:@mescius/wijmo.undo/index.js',
'@mescius/wijmo.interop.grid': 'npm:@mescius/wijmo.interop.grid/index.js',
'@mescius/wijmo.touch': 'npm:@mescius/wijmo.touch/index.js',
'@mescius/wijmo.cloud': 'npm:@mescius/wijmo.cloud/index.js',
'@mescius/wijmo.barcode': 'npm:@mescius/wijmo.barcode/index.js',
'@mescius/wijmo.barcode.common': 'npm:@mescius/wijmo.barcode.common/index.js',
'@mescius/wijmo.barcode.composite': 'npm:@mescius/wijmo.barcode.composite/index.js',
'@mescius/wijmo.barcode.specialized': 'npm:@mescius/wijmo.barcode.specialized/index.js',
"@mescius/wijmo.vue2.chart.analytics": "npm:@mescius/wijmo.vue2.chart.analytics/index.js",
"@mescius/wijmo.vue2.chart.animation": "npm:@mescius/wijmo.vue2.chart.animation/index.js",
"@mescius/wijmo.vue2.chart.annotation": "npm:@mescius/wijmo.vue2.chart.annotation/index.js",
"@mescius/wijmo.vue2.chart.finance.analytics": "npm:@mescius/wijmo.vue2.chart.finance.analytics/index.js",
"@mescius/wijmo.vue2.chart.finance": "npm:@mescius/wijmo.vue2.chart.finance/index.js",
"@mescius/wijmo.vue2.chart.hierarchical": "npm:@mescius/wijmo.vue2.chart.hierarchical/index.js",
"@mescius/wijmo.vue2.chart.interaction": "npm:@mescius/wijmo.vue2.chart.interaction/index.js",
"@mescius/wijmo.vue2.chart.radar": "npm:@mescius/wijmo.vue2.chart.radar/index.js",
'@mescius/wijmo.vue2.chart.map': 'npm:@mescius/wijmo.vue2.chart.map/index.js',
"@mescius/wijmo.vue2.chart": "npm:@mescius/wijmo.vue2.chart/index.js",
"@mescius/wijmo.vue2.core": "npm:@mescius/wijmo.vue2.core/index.js",
"@mescius/wijmo.vue2.gauge": "npm:@mescius/wijmo.vue2.gauge/index.js",
"@mescius/wijmo.vue2.grid.detail": "npm:@mescius/wijmo.vue2.grid.detail/index.js",
"@mescius/wijmo.vue2.grid.filter": "npm:@mescius/wijmo.vue2.grid.filter/index.js",
"@mescius/wijmo.vue2.grid.grouppanel": "npm:@mescius/wijmo.vue2.grid.grouppanel/index.js",
'@mescius/wijmo.vue2.grid.search': 'npm:@mescius/wijmo.vue2.grid.search/index.js',
"@mescius/wijmo.vue2.grid.multirow": "npm:@mescius/wijmo.vue2.grid.multirow/index.js",
"@mescius/wijmo.vue2.grid.sheet": "npm:@mescius/wijmo.vue2.grid.sheet/index.js",
'@mescius/wijmo.vue2.grid.transposed': 'npm:@mescius/wijmo.vue2.grid.transposed/index.js',
'@mescius/wijmo.vue2.grid.transposedmultirow': 'npm:@mescius/wijmo.vue2.grid.transposedmultirow/index.js',
"@mescius/wijmo.vue2.grid": "npm:@mescius/wijmo.vue2.grid/index.js",
"@mescius/wijmo.vue2.input": "npm:@mescius/wijmo.vue2.input/index.js",
"@mescius/wijmo.vue2.olap": "npm:@mescius/wijmo.vue2.olap/index.js",
"@mescius/wijmo.vue2.viewer": "npm:@mescius/wijmo.vue2.viewer/index.js",
"@mescius/wijmo.vue2.nav": "npm:@mescius/wijmo.vue2.nav/index.js",
"@mescius/wijmo.vue2.base": "npm:@mescius/wijmo.vue2.base/index.js",
'@mescius/wijmo.vue2.barcode.common': 'npm:@mescius/wijmo.vue2.barcode.common/index.js',
'@mescius/wijmo.vue2.barcode.composite': 'npm:@mescius/wijmo.vue2.barcode.composite/index.js',
'@mescius/wijmo.vue2.barcode.specialized': 'npm:@mescius/wijmo.vue2.barcode.specialized/index.js',
'bootstrap.css': 'npm:bootstrap/dist/css/bootstrap.min.css',
'jszip': 'npm:jszip/dist/jszip.js',
'css': 'npm:systemjs-plugin-css/css.js',
'vue': 'npm:vue/dist/vue.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'@vue/compiler-dom':'npm:@vue/compiler-dom/dist/compiler-dom.global.prod.js',
'@vue/runtime-dom':'npm:@vue/runtime-dom/dist/runtime-dom.global.prod.js',
'@vue/shared':'npm:@vue/shared/dist/shared.cjs.js',
'vue-loader': 'npm:systemjs-vue-browser/index.js',
//'systemjs-plugin-vue': 'npm:systemjs-plugin-vue/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'js'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
wijmo: {
defaultExtension: 'js',
}
}
});
})(this);